<template>
  <div ref="dropdown" class="btn-group">
    <button
      class="btn-primary-link dropdown-toggle"
      type="button"
      :class="classes.button"
      @click="isOpen = !isOpen"
    >
      <slot name="placeholder">{{ placeholder }}</slot>
      <i v-if="classes.button.includes('btn-order')" class="icon-sort"></i>
    </button>
    <transition-slide-fade>
      <ul v-show="isOpen" class="dropdown-menu" :class="[classes.menu]">
        <slot name="menu"></slot>
      </ul>
    </transition-slide-fade>
  </div>
</template>

<script>
import TransitionSlideFade from '@/components/transitions/TransitionSlideFade.vue'
export default {
  name: 'BaseDropdown',
  components: { TransitionSlideFade },
  inheritAttrs: false,
  props: {
    placeholder: {
      type: String,
      required: false,
      default: null,
    },
    classes: {
      type: Object,
      required: false,
      default: () => ({
        button: '',
        menu: '',
      }),
    },
  },
  data() {
    return {
      isOpen: false,
    }
  },
  mounted() {
    /**
     * @param {MouseEvent} e
     */
    window.onclick = (e) => {
      if (!this.$refs.dropdown.contains(e.target)) {
        this.isOpen = false
      }
    }
  },
  destroyed() {
    window.onclick = null
  },
}
</script>
